/*                              -*- Mode: C++ -*- 
 * cdbClasses.h --- utilities to manipulate the softwareobject
 *                   classes hierarchie
 * Author          : Nicolas Anquetil
 * Created On      : Mon Aug 18 12:14:52 1997
 */ 

/* This file must be readable by C, beware to the comments */


# ifndef CDBCLASSES_H
# define CDBCLASSES_H

# include "c++_c.h"

/* This file may be read by C, some beware to the comments */

// Simulates reflexion in C++, list of all the classes in
// SoftwareObject hierarchy (see also `is_a' methods in the
// SoftwareObjects)

typedef enum allClasses {

  /* the cdbAbstractClasses */
  _sourcewithinfile, _softwareobject, _sourceunit, _referenceexistence, 
  _definition, _typeddefinition, _standalonedefinition, _sourceblock,

  /* now the _actual_ classes followed by their respective virtual class*/
  _fileinclusionexistence, _sourcefile, _file,                    // virtualizes to _file
  _routinecallexistence,_routinesource, _routine,                    // virtualizes to _routine
  _datauseexistence,_datumdef, _field, _enumerationconst, _data,  // virtualizes to _data 
  _typeuseexistence, _recordtypedef, _enumeratedtypedef,_typedef,  _type, //    to _type
  _commenttermexistence, _specialcodeexistence,_manifestconstexistence, // to _nullclass
  _nullclass

} class_t;


// maximum number of elements in the class_t enumeration type
# define MAX_CLASSES ((int)_nullclass)

EXTERNC bool    isCdbVirtualClass( class_t);
EXTERNC bool    isCdbAbstractClass( class_t);
EXTERNC bool    isCdbDefinitionClass( class_t);
EXTERNC bool    isCdbReferenceClass( class_t);
EXTERNC bool    isCdbSuperClass( class_t, class_t);

EXTERNC char   *cdbClass2str(class_t);
EXTERNC char   *cdbClass2abbrev(class_t);
EXTERNC class_t str2cdbClass(char*);
EXTERNC int     compatibleclass( class_t, class_t);
EXTERNC class_t virtualizeclass( class_t);

# endif
