//                              -*- Mode: C++ -*-
// main.cc --- Main program to test the new DataBase model implementation
// Author          : Nicolas Anquetil
// Created On      : Thu Nov 28 12:13:48 1996
// Last Modified By: Nicolas Anquetil
// Last Modified On: Thu Feb  6 09:55:04 1997
//


# include "../write-API.hh"
# include "utilFileMem.h"


void printName(char *n, char *x);
void printAllObjects();

main( int argc, char *argv[])
// --------------------------------------------------
{
  SourceFile *f1;
  SourceFile *f2;
  RoutineSource *r1;

  RecordTypeDef *t1;
  TypeDef *t2;
  EnumeratedTypeDef *t3;

  Field    *fd1;
  EnumerationConst *ec1;

  DatumDef *d1, *d2, *d3, *d4;

  DataUseExistence *du1, *du2, *du3;
  FileInclusionExistence *fi;
  RoutineCallExistence *rc;
  CommentTermExistence *ct;

  int result;
  int useMode;
  int fileMode;

// This is here merely so there is code I can change that has no
// effect. This allows me to test if filemem is working.
  int bigarray[120];
  
  bigarray[251] = 1;
  bigarray[252] = 1;
  bigarray[253] = 1;
  bigarray[254] = 1;



  cout << "Enter 1 for creation, 0 to use existing\n";
  cin >> useMode;
  cout << "mode entered is: " << useMode << " test=" << bigarray[124] << "\n";
   
  fileMode = useMode ? UFM_NEW : UFM_WRITE;
  result = initGrowableFileMem("testx.mf", fileMode, 1, 100);
  if(result != 0)  
  { 
    printf("Failed to init file mem rc=%d\n", result);
    exit(0);
  }

  if(useMode == 0)
  {
    init_pointers_from_db();
    printAllObjects();
  }
  else
  {
    init_pointers();

/* 0 type 2 SourceFile */
    f1 = cdbCreateSourceFile("file.tst1",31,"/usr/games/kbre",98765,1996);

    char buffer[200]="file    ";
    for (int i = 1; i< 3; i++)
    {        
       sprintf(buffer, "file%d", i);
/* 1,2 type 2 SourceFile */
       f2 =cdbCreateSourceFile(buffer,32,"/usr/games/kbre",43210,1997);
    }

/* 3 type 9 FileInclusionExistence */
    fi = cdbRegisterFileInclusion( f1, "includedfile");

/* 4 type 22 RecordTypeDef */
    t1 = (RecordTypeDef *)cdbCreateTypeDef(f1, "type_tst1_rec", NULL, true, false, 12,144);
/* 5 type 18 TypeDef */
    t2 = cdbCreateTypeDef(f1, "type_tst2", NULL, false, false, 12,144);
/* 6 type 22 (should be 21 EnumeratedTypeDef) */
    t3 = (EnumeratedTypeDef *)cdbCreateTypeDef(f1, "type_tst3_enum", NULL, true, false, 12,144);

/* 7 type 17 Field */
    fd1 = cdbCreateField(t1, "field_tst1", NULL);

/* 8 type 20 EnumerationConst */
    ec1 = cdbCreateEnumerationConst( t3, "ec3_enumconst");

/* 9 type 10 DataUseExistence *** ERROR ****** */
    du1 = cdbRegisterDataUse( f2,"datause_tst1", NULL, false, false);
/* 10 type 11 ManifestConstExistence */ 
    du2 = cdbRegisterDataUse( f2,"datause_tst2_manconst", NULL, true, false);
/* 11 type 12 TypeUseExistence */
    du3 = cdbRegisterDataUse( f2,"datause_tst3_typeuse", NULL, false, true);

/* 12 type 7 CommentTermExistence *** ERROR ****** */
    ct = cdbRegisterCommentTerm (f1, "commentterm", NULL, false);

/* 13 type 12 */
/* 14 type 4 RoutineSource */
    r1 = cdbCreateRoutineSource( f2, buffer, "type_tst1", 25, 625, false);

/* 15 type 13 RoutineCallExistence */
    rc = cdbRegisterRoutineCall( r1, "callingRoutine");

/* 16 type 19 DatumDef */
    d1 = cdbCreateDatumDef(r1, "data_tst1_formarg", true, false, "type_tst1", 20, 400);
/* 17 type 19 */
    d2 = cdbCreateDatumDef(f1, "data_tst2_const", false, true, "type_tst1", 20, 400);
/* 18 type 19 */
    d3 = cdbCreateDatumDef(f2, "data_tst3", false, false, "type_tst1", 20, 400);
/* 19 type 19 */
    d4 = cdbCreateDatumDef(r1, "data_tst4", false, false, NULL, 20, 400);

  }
 
  printf("> All Names: ----------------------------------------- <\n");
  the_DB->allNamesDo(printName, "");
  putchar('\n');

//  printf("> -------------------------------------------------- <\n");
//  fd1->hello();
//  putchar('\n');
  printAllObjects();
  debugPrintFileMem();
//  debugDumpAll();
  terminateFileMem();

}

void printName(char *n, char *x)
{
  printf("name -> %s\n", ((Name *)n)->string());

}

void printAllObjects()
{
  printf("Dumping Information About All Objects ----->\n");
    for(int i=0; i<the_DB->allObjects()->size(); i++)
    {
      SoftwareObject *theObject;
      theObject = ((*(the_DB->allObjects()))[i]);
      printf("Object number %d type=%d\n",i,theObject->classType());
      debugPrintMem(theObject);
    }
  printf("End of dump of all objects\n");
}
