//                              -*- Mode: C++ -*-
// main.cc --- trying to include parser to build a DB
// Author          : Nicolas Anquetil
// Created On      : Tue Jan 21 14:57:36 1997
//


# include "testparser.hh"
# include "opq.h"
extern "C" opq_main();


/**************************************************
              M A I N   F U N C T I O N
 **************************************************/


void printName(char *n, char *x)
/**************************************************
 */
{
  printf("name -> %s\n", ((Name *)n)->string());
}



void mainParsing(int argc, char *argv[])
/**************************************************
 */
{
  int useMode;
  int result;

//   cout << "Enter 1 for creation, 0 to use existing\n";
//   cin >> useMode;
//   cout << "mode entered is: " << useMode << "\n";
  useMode = 1;

  result = initGrowableFileMem( "test.mf",
				(useMode ? UFM_NEW : UFM_WRITE),
				1, 100);
  if(result != 0) { 
    printf("Failed to init file mem rc=%d\n", result);
    exit(2);
  }

  if(useMode == 0) {
    init_pointers_from_db();
  }
  else {
    init_pointers();
# ifdef BUILDER
    fakedmain(argc,argv);
# endif
  }

  printf("> -------------------------------------------------- <\n");
  printf("Name(s) created :\n");
  the_DB->allNamesDo(printName, NULL);
  putchar('\n');
}

EXTERNC char *className(class_t classType);

void main(int argc, char *argv[])
/**************************************************
 */
{
  int result;

  if (strcmp(argv[0],"testparser") == 0) {
	printf("parsing...\n");
	mainParsing(argc, argv);    // builds the DB
  }
  else {

	printf("query module...\n");

// 	result = cdbInitReadOnlyFileMem("test.mf");
// 	if (result != 0) {
// 	  printf("Failed to init file mem rc=%d\n", result);
// 	  exit(2);
// 	}
// 	init_pointers_from_db();

# ifdef QUERY
	opq_main(argc,argv);		  // reads the DB
# endif
  }

  terminateFileMem();
}
